Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs	(revision 17698)
@@ -88,5 +88,5 @@
     public override IOperation InstrumentedApply() {
       //choose default encoding here
-      VRPToursParameter.ActualValue = AlbaEncoding.ConvertFrom(CreateSolution(), ProblemInstance);
+      VRPToursParameter.ActualValue = AlbaEncodedSolution.ConvertFrom(CreateSolution(), ProblemInstance);
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs	(revision 17698)
@@ -49,13 +49,13 @@
     }
 
-    protected abstract AlbaEncoding Crossover(IRandom random, AlbaEncoding parent1, AlbaEncoding parent2);
+    protected abstract AlbaEncodedSolution Crossover(IRandom random, AlbaEncodedSolution parent1, AlbaEncodedSolution parent2);
 
     public override IOperation InstrumentedApply() {
-      ItemArray<IVRPEncoding> parents = new ItemArray<IVRPEncoding>(ParentsParameter.ActualValue.Length);
+      ItemArray<IVRPEncodedSolution> parents = new ItemArray<IVRPEncodedSolution>(ParentsParameter.ActualValue.Length);
       for (int i = 0; i < ParentsParameter.ActualValue.Length; i++) {
-        IVRPEncoding solution = ParentsParameter.ActualValue[i];
+        IVRPEncodedSolution solution = ParentsParameter.ActualValue[i];
 
-        if (!(solution is AlbaEncoding)) {
-          parents[i] = AlbaEncoding.ConvertFrom(solution, ProblemInstance);
+        if (!(solution is AlbaEncodedSolution)) {
+          parents[i] = AlbaEncodedSolution.ConvertFrom(solution, ProblemInstance);
         } else {
           parents[i] = solution;
@@ -65,6 +65,6 @@
 
       ChildParameter.ActualValue =
-        Crossover(RandomParameter.ActualValue, parents[0] as AlbaEncoding, parents[1] as AlbaEncoding);
-      (ChildParameter.ActualValue as AlbaEncoding).Repair();
+        Crossover(RandomParameter.ActualValue, parents[0] as AlbaEncodedSolution, parents[1] as AlbaEncodedSolution);
+      (ChildParameter.ActualValue as AlbaEncodedSolution).Repair();
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs	(revision 17698)
@@ -50,9 +50,9 @@
     }
 
-    protected override AlbaEncoding Crossover(IRandom random, AlbaEncoding parent1, AlbaEncoding parent2) {
+    protected override AlbaEncodedSolution Crossover(IRandom random, AlbaEncodedSolution parent1, AlbaEncodedSolution parent2) {
       //note - the inner crossover is called here and the result is converted to an alba representation
       //some refactoring should be done here in the future - the crossover operation should be called directly
       if (parent1.Length != parent2.Length)
-        return parent1.Clone() as AlbaEncoding;
+        return parent1.Clone() as AlbaEncodedSolution;
 
       InnerCrossoverParameter.ActualValue.ParentsParameter.ActualName = ParentsParameter.ActualName;
@@ -66,5 +66,5 @@
         ExecutionContext.Scope.Variables.Remove(childName);
 
-        return new AlbaEncoding(permutation, ProblemInstance);
+        return new AlbaEncodedSolution(permutation, ProblemInstance);
       } else
         return null;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs	(revision 17698)
@@ -45,6 +45,6 @@
     }
 
-    public ILookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ILookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ILookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ILookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
 
@@ -75,5 +75,5 @@
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The amount of evaluated solutions (here a move is counted only as 4/n evaluated solutions with n being the length of the permutation)."));
       Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection where to store results."));
-      Parameters.Add(new LookupParameter<IVRPEncoding>("VRPTours", "The VRP tours to be manipulated."));
+      Parameters.Add(new LookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours to be manipulated."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality value of the assignment."));
       Parameters.Add(new ValueParameter<IntValue>("Lambda", "The lambda value.", new IntValue(1)));
@@ -86,5 +86,5 @@
     }
 
-    public static void Apply(AlbaEncoding solution, int maxIterations,
+    public static void Apply(AlbaEncodedSolution solution, int maxIterations,
       int lambda, int samples, IRandom random, IVRPProblemInstance problemInstance, ref double quality, out int evaluatedSolutions) {
       evaluatedSolutions = 0;
@@ -93,5 +93,5 @@
         AlbaLambdaInterchangeMove bestMove = null;
         foreach (AlbaLambdaInterchangeMove move in AlbaStochasticLambdaInterchangeMultiMoveGenerator.GenerateAllMoves(solution, problemInstance, lambda, samples, random)) {
-          AlbaEncoding newSolution = solution.Clone() as AlbaEncoding;
+          AlbaEncodedSolution newSolution = solution.Clone() as AlbaEncodedSolution;
           AlbaLambdaInterchangeMoveMaker.Apply(newSolution, move);
           double moveQuality =
@@ -111,10 +111,10 @@
     public override IOperation InstrumentedApply() {
       int maxIterations = MaximumIterationsParameter.ActualValue.Value;
-      AlbaEncoding solution = null;
+      AlbaEncodedSolution solution = null;
 
-      if (VRPToursParameter.ActualValue is AlbaEncoding)
-        solution = VRPToursParameter.ActualValue as AlbaEncoding;
+      if (VRPToursParameter.ActualValue is AlbaEncodedSolution)
+        solution = VRPToursParameter.ActualValue as AlbaEncodedSolution;
       else
-        VRPToursParameter.ActualValue = solution = AlbaEncoding.ConvertFrom(VRPToursParameter.ActualValue, ProblemInstance);
+        VRPToursParameter.ActualValue = solution = AlbaEncodedSolution.ConvertFrom(VRPToursParameter.ActualValue, ProblemInstance);
 
       int lambda = LambdaParameter.Value.Value;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs	(revision 17698)
@@ -43,6 +43,6 @@
     }
 
-    protected override void Manipulate(IRandom random, AlbaEncoding individual) {
-      AlbaEncoding original = (AlbaEncoding)individual.Clone();
+    protected override void Manipulate(IRandom random, AlbaEncodedSolution individual) {
+      AlbaEncodedSolution original = (AlbaEncodedSolution)individual.Clone();
       int cutIndex, insertIndex, number;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs	(revision 17698)
@@ -44,5 +44,5 @@
     }
 
-    protected override void Manipulate(IRandom random, AlbaEncoding individual) {
+    protected override void Manipulate(IRandom random, AlbaEncodedSolution individual) {
       int breakPoint1, breakPoint2;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs	(revision 17698)
@@ -43,5 +43,5 @@
     }
 
-    protected override void Manipulate(IRandom random, AlbaEncoding individual) {
+    protected override void Manipulate(IRandom random, AlbaEncodedSolution individual) {
       int index1, index2, temp;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs	(revision 17698)
@@ -44,5 +44,5 @@
     }
 
-    public static void Apply(AlbaEncoding individual, int index1, int index2) {
+    public static void Apply(AlbaEncodedSolution individual, int index1, int index2) {
       if (index1 != -1 && index2 != -1) {
         int breakPoint1 = index1 + 1;
@@ -56,5 +56,5 @@
     }
 
-    protected override void Manipulate(IRandom rand, AlbaEncoding individual) {
+    protected override void Manipulate(IRandom rand, AlbaEncodedSolution individual) {
       int index1 = -1;
       int index2 = -1;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs	(revision 17698)
@@ -52,5 +52,5 @@
     }
 
-    public static void Apply(AlbaEncoding individual, int tour1Index, int position1, int length1,
+    public static void Apply(AlbaEncodedSolution individual, int tour1Index, int position1, int length1,
       int tour2Index, int position2, int length2) {
       List<Tour> tours = individual.GetTours();
@@ -74,5 +74,5 @@
       }
 
-      AlbaEncoding original = individual.Clone() as AlbaEncoding;
+      AlbaEncodedSolution original = individual.Clone() as AlbaEncodedSolution;
       int index = 0;
 
@@ -106,5 +106,5 @@
     }
 
-    protected override void Manipulate(IRandom rand, AlbaEncoding individual) {
+    protected override void Manipulate(IRandom rand, AlbaEncodedSolution individual) {
       List<Tour> tours = individual.GetTours();
       if (tours.Count > 1) {
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs	(revision 17698)
@@ -48,7 +48,7 @@
     }
 
-    protected abstract void Manipulate(IRandom random, AlbaEncoding individual);
+    protected abstract void Manipulate(IRandom random, AlbaEncodedSolution individual);
 
-    protected int FindCustomerLocation(int customer, AlbaEncoding individual) {
+    protected int FindCustomerLocation(int customer, AlbaEncodedSolution individual) {
       int pos = -1;
       for (int i = 0; i < individual.Length; i++) {
@@ -63,11 +63,11 @@
 
     public override IOperation InstrumentedApply() {
-      IVRPEncoding solution = VRPToursParameter.ActualValue;
-      if (!(solution is AlbaEncoding)) {
-        VRPToursParameter.ActualValue = AlbaEncoding.ConvertFrom(solution, ProblemInstance);
+      IVRPEncodedSolution solution = VRPToursParameter.ActualValue;
+      if (!(solution is AlbaEncodedSolution)) {
+        VRPToursParameter.ActualValue = AlbaEncodedSolution.ConvertFrom(solution, ProblemInstance);
       }
 
-      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as AlbaEncoding);
-      (VRPToursParameter.ActualValue as AlbaEncoding).Repair();
+      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as AlbaEncodedSolution);
+      (VRPToursParameter.ActualValue as AlbaEncodedSolution).Repair();
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs	(revision 17698)
@@ -50,5 +50,5 @@
     }
 
-    protected override void Manipulate(IRandom random, AlbaEncoding individual) {
+    protected override void Manipulate(IRandom random, AlbaEncodedSolution individual) {
       InnerManipulatorParameter.ActualValue.PermutationParameter.ActualName = VRPToursParameter.ActualName;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs	(revision 17698)
@@ -42,7 +42,7 @@
 
     public override IOperation InstrumentedApply() {
-      IVRPEncoding solution = VRPToursParameter.ActualValue;
-      if (!(solution is AlbaEncoding)) {
-        VRPToursParameter.ActualValue = AlbaEncoding.ConvertFrom(solution, ProblemInstance);
+      IVRPEncodedSolution solution = VRPToursParameter.ActualValue;
+      if (!(solution is AlbaEncodedSolution)) {
+        VRPToursParameter.ActualValue = AlbaEncodedSolution.ConvertFrom(solution, ProblemInstance);
       }
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs	(revision 17698)
@@ -46,5 +46,5 @@
     }
 
-    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance) {
+    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance) {
       List<AlbaIntraRouteInversionMove> moves = new List<AlbaIntraRouteInversionMove>();
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs	(revision 17698)
@@ -55,5 +55,5 @@
 
     protected override void EvaluateMove() {
-      AlbaEncoding newSolution = IntraRouteInversionMoveParameter.ActualValue.Permutation.Clone() as AlbaEncoding;
+      AlbaEncodedSolution newSolution = IntraRouteInversionMoveParameter.ActualValue.Permutation.Clone() as AlbaEncodedSolution;
       AlbaIntraRouteInversionMoveMaker.Apply(newSolution, IntraRouteInversionMoveParameter.ActualValue);
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs	(revision 17698)
@@ -32,5 +32,5 @@
   [StorableType("F0A32074-2D3F-4236-A732-8C095FA5F64E")]
   public class AlbaIntraRouteInversionMove : TwoIndexMove, IVRPMove {
-    public IVRPEncoding Individual { get { return Permutation as AlbaEncoding; } }
+    public IVRPEncodedSolution Individual { get { return Permutation as AlbaEncodedSolution; } }
 
     [StorableConstructor]
@@ -49,7 +49,7 @@
     }
 
-    public AlbaIntraRouteInversionMove(int index1, int index2, AlbaEncoding permutation)
+    public AlbaIntraRouteInversionMove(int index1, int index2, AlbaEncodedSolution permutation)
       : base(index1, index2, null) {
-      this.Permutation = permutation.Clone() as AlbaEncoding;
+      this.Permutation = permutation.Clone() as AlbaEncodedSolution;
     }
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs	(revision 17698)
@@ -56,10 +56,10 @@
     }
 
-    protected abstract AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance);
+    protected abstract AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance);
 
     public override IOperation InstrumentedApply() {
       IOperation next = base.InstrumentedApply();
 
-      AlbaEncoding individual = VRPToursParameter.ActualValue as AlbaEncoding;
+      AlbaEncodedSolution individual = VRPToursParameter.ActualValue as AlbaEncodedSolution;
       AlbaIntraRouteInversionMove[] moves = GenerateMoves(individual, ProblemInstance);
       Scope[] moveScopes = new Scope[moves.Length];
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs	(revision 17698)
@@ -54,5 +54,5 @@
     }
 
-    public static void Apply(AlbaEncoding solution, AlbaIntraRouteInversionMove move) {
+    public static void Apply(AlbaEncodedSolution solution, AlbaIntraRouteInversionMove move) {
       AlbaIntraRouteInversionManipulator.Apply(solution, move.Index1, move.Index2);
     }
@@ -61,6 +61,6 @@
       AlbaIntraRouteInversionMove move = IntraRouteInversionMoveParameter.ActualValue;
 
-      Apply(move.Individual as AlbaEncoding, move);
-      VRPToursParameter.ActualValue = move.Individual as AlbaEncoding;
+      Apply(move.Individual as AlbaEncodedSolution, move);
+      VRPToursParameter.ActualValue = move.Individual as AlbaEncodedSolution;
     }
   }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs	(revision 17698)
@@ -59,5 +59,5 @@
     }
 
-    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance) {
+    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance) {
       int sampleSize = SampleSizeParameter.ActualValue.Value;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs	(revision 17698)
@@ -61,5 +61,5 @@
     }
 
-    public static AlbaIntraRouteInversionMove Apply(AlbaEncoding individual, int cities, IRandom rand) {
+    public static AlbaIntraRouteInversionMove Apply(AlbaEncodedSolution individual, int cities, IRandom rand) {
       int index1 = -1;
       int index2 = -1;
@@ -96,5 +96,5 @@
     }
 
-    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance) {
+    protected override AlbaIntraRouteInversionMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance) {
       List<AlbaIntraRouteInversionMove> moves = new List<AlbaIntraRouteInversionMove>();
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs	(revision 17698)
@@ -47,5 +47,5 @@
     }
 
-    protected override AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance, int lambda) {
+    protected override AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance, int lambda) {
       List<AlbaLambdaInterchangeMove> moves = new List<AlbaLambdaInterchangeMove>();
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs	(revision 17698)
@@ -32,5 +32,5 @@
   public class AlbaLambdaInterchangeMove : Item, IVRPMove {
     [Storable]
-    public IVRPEncoding Individual { get; protected set; }
+    public IVRPEncodedSolution Individual { get; protected set; }
 
     [Storable]
@@ -66,5 +66,5 @@
 
     public AlbaLambdaInterchangeMove(int tour1, int position1, int length1,
-      int tour2, int position2, int length2, AlbaEncoding permutation) {
+      int tour2, int position2, int length2, AlbaEncodedSolution permutation) {
       Tour1 = tour1;
       Position1 = position1;
@@ -75,5 +75,5 @@
       Length2 = length2;
 
-      this.Individual = permutation.Clone() as AlbaEncoding;
+      this.Individual = permutation.Clone() as AlbaEncodedSolution;
     }
 
@@ -95,5 +95,5 @@
       this.Length2 = original.Length2;
 
-      this.Individual = cloner.Clone(Individual) as AlbaEncoding;
+      this.Individual = cloner.Clone(Individual) as AlbaEncodedSolution;
     }
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs	(revision 17698)
@@ -55,5 +55,5 @@
 
     protected override void EvaluateMove() {
-      AlbaEncoding newSolution = LambdaInterchangeMoveParameter.ActualValue.Individual.Clone() as AlbaEncoding;
+      AlbaEncodedSolution newSolution = LambdaInterchangeMoveParameter.ActualValue.Individual.Clone() as AlbaEncodedSolution;
       AlbaLambdaInterchangeMoveMaker.Apply(newSolution, LambdaInterchangeMoveParameter.ActualValue);
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs	(revision 17698)
@@ -66,10 +66,10 @@
     }
 
-    protected abstract AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance, int lambda);
+    protected abstract AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance, int lambda);
 
     public override IOperation InstrumentedApply() {
       IOperation next = base.InstrumentedApply();
 
-      AlbaEncoding individual = VRPToursParameter.ActualValue as AlbaEncoding;
+      AlbaEncodedSolution individual = VRPToursParameter.ActualValue as AlbaEncodedSolution;
       AlbaLambdaInterchangeMove[] moves = GenerateMoves(individual, ProblemInstanceParameter.ActualValue, LambdaParameter.Value.Value);
       Scope[] moveScopes = new Scope[moves.Length];
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs	(revision 17698)
@@ -57,5 +57,5 @@
     }
 
-    public static void Apply(AlbaEncoding solution, AlbaLambdaInterchangeMove move) {
+    public static void Apply(AlbaEncodedSolution solution, AlbaLambdaInterchangeMove move) {
       AlbaLambdaInterchangeManipulator.Apply(
         solution,
@@ -67,5 +67,5 @@
       AlbaLambdaInterchangeMove move = LambdaInterchangeMoveParameter.ActualValue;
 
-      Apply(move.Individual as AlbaEncoding, move);
+      Apply(move.Individual as AlbaEncodedSolution, move);
       VRPToursParameter.ActualValue = move.Individual;
     }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs	(revision 17698)
@@ -59,5 +59,5 @@
     }
 
-    public static AlbaLambdaInterchangeMove[] GenerateAllMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance, int lambda, int sampleSize, IRandom rand) {
+    public static AlbaLambdaInterchangeMove[] GenerateAllMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance, int lambda, int sampleSize, IRandom rand) {
       AlbaLambdaInterchangeMove[] moves = new AlbaLambdaInterchangeMove[sampleSize];
       for (int i = 0; i < sampleSize; i++) {
@@ -69,5 +69,5 @@
     }
 
-    protected override AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncoding individual, IVRPProblemInstance problemInstance, int lambda) {
+    protected override AlbaLambdaInterchangeMove[] GenerateMoves(AlbaEncodedSolution individual, IVRPProblemInstance problemInstance, int lambda) {
       return GenerateAllMoves(individual, problemInstance, lambda, SampleSizeParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
